﻿/*Copyright (c) 2017 Grégoire Meyer
 * 
    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
 * */

using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;


[ExecuteInEditMode]
public class SigianGrid : MonoBehaviour {

    public float SnapValue = 1;
	public bool isActivated = true;

	// Update is called once per frame
	void Update ()
    {
		if (isActivated)
        {
			foreach(GameObject GO in Selection.gameObjects)
			{
				float inverseSnap = 1 / SnapValue;

				float snappedX = Mathf.Round(GO.transform.position.x * inverseSnap) / inverseSnap;
				float snappedY = Mathf.Round(GO.transform.position.y * inverseSnap) / inverseSnap;
				float snappedZ = Mathf.Round(GO.transform.position.z * inverseSnap) / inverseSnap;

				if(!float.IsNaN (snappedX) && !float.IsNaN (snappedY) && !float.IsNaN (snappedZ))
				{
					GO.transform.position = new Vector3(snappedX, snappedY, snappedZ);
				}   
			}			                    
        }
	}
}

